import {
  styleExpressionProperty
} from "./chunk.ADPMTWTS.js";
import {
  tokens
} from "./chunk.LOUXU5LA.js";
import {
  GdsElement
} from "./chunk.ZQ4D5K7J.js";
import {
  gdsCustomElement,
  html
} from "./chunk.VOYMQ322.js";
import {
  __decorateClass
} from "./chunk.5VURDMKE.js";

// libs/core/src/components/layout/grid/grid.style.ts
import { css } from "lit";
var style = css`
  :host {
    --_c: 12;
    --_grid-col: repeat(var(--_c), 1fr);
    display: grid;
    width: 100%;
    grid-template-columns: var(--_grid-col);
    grid-column-gap: var(--_gap-column, 0px);
    grid-row-gap: var(--_gap-row, 0px);
  }

  :host([auto-columns]) {
    --_col-count: var(--_c, 0);
    --_gap-count: calc(var(--_col-count) - 1);
    --_total-gap-width: calc(var(--_gap-count) * var(--_gap-column, 0px));
    --_col-width-max: calc(
      (100% - var(--_total-gap-width)) / var(--_col-count)
    );
    grid-template-columns: repeat(
      auto-fill,
      minmax(max(var(--_col-width), var(--_col-width-max)), 1fr)
    );
  }
`;
var grid_style_default = style;

// libs/core/src/components/layout/grid/grid.ts
var GdsGrid = class extends GdsElement {
  render() {
    return html`<slot></slot>`;
  }
};
GdsGrid.styles = [tokens, grid_style_default];
__decorateClass([
  styleExpressionProperty({
    property: "--_c",
    valueTemplate: (v) => v
  })
], GdsGrid.prototype, "columns", 2);
__decorateClass([
  styleExpressionProperty({
    styleTemplate: (_prop, values) => {
      const colGap = values[0];
      const rowGap = values[1] || colGap;
      return `--_gap-column: ${colGap}; --_gap-row: ${rowGap};`;
    }
  })
], GdsGrid.prototype, "gap", 2);
__decorateClass([
  styleExpressionProperty()
], GdsGrid.prototype, "padding", 2);
__decorateClass([
  styleExpressionProperty({
    attribute: "auto-columns",
    property: "--_col-width",
    valueTemplate: (v) => `${v}px`
  })
], GdsGrid.prototype, "autoColumns", 2);
GdsGrid = __decorateClass([
  gdsCustomElement("gds-grid")
], GdsGrid);

export {
  GdsGrid
};
